-------------------------------------------------------------------------------
-- warp_timer_plbw_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library warp_timer_plbw_v1_02_b;
use warp_timer_plbw_v1_02_b.all;

entity warp_timer_plbw_0_wrapper is
  port (
    splb_clk : in std_logic;
    idlefordifs : in std_logic;
    plb_abus : in std_logic_vector(0 to 31);
    plb_pavalid : in std_logic;
    plb_rnw : in std_logic;
    plb_wrdbus : in std_logic_vector(0 to 63);
    splb_rst : in std_logic;
    sl_addrack : out std_logic;
    sl_rdcomp : out std_logic;
    sl_rddack : out std_logic;
    sl_rddbus : out std_logic_vector(0 to 63);
    sl_wait : out std_logic;
    sl_wrcomp : out std_logic;
    sl_wrdack : out std_logic;
    timer0_active : out std_logic;
    timer1_active : out std_logic;
    timer2_active : out std_logic;
    timer3_active : out std_logic;
    timer4_active : out std_logic;
    timer5_active : out std_logic;
    timer6_active : out std_logic;
    timer7_active : out std_logic;
    timerexpire : out std_logic
  );

  attribute x_core_info : STRING;
  attribute x_core_info of warp_timer_plbw_0_wrapper : entity is "warp_timer_plbw_v1_02_b";

end warp_timer_plbw_0_wrapper;

architecture STRUCTURE of warp_timer_plbw_0_wrapper is

  component warp_timer_plbw is
    generic (
      C_BASEADDR : std_logic_vector(0 to 31);
      C_HIGHADDR : std_logic_vector(0 to 31);
      C_SPLB_AWIDTH : INTEGER;
      C_SPLB_DWIDTH : INTEGER;
      C_SPLB_P2P : INTEGER;
      C_SPLB_MID_WIDTH : INTEGER;
      C_SPLB_NUM_MASTERS : INTEGER;
      C_SPLB_SUPPORT_BURSTS : INTEGER;
      C_SPLB_NATIVE_DWIDTH : INTEGER;
      C_MEMMAP_TIMER_STATUS : integer;
      C_MEMMAP_TIMER_STATUS_N_BITS : integer;
      C_MEMMAP_TIMER_STATUS_BIN_PT : integer;
      C_MEMMAP_TIMER0_SLOTCOUNT : integer;
      C_MEMMAP_TIMER0_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER0_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER1_SLOTCOUNT : integer;
      C_MEMMAP_TIMER1_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER1_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER2_SLOTCOUNT : integer;
      C_MEMMAP_TIMER2_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER2_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER3_SLOTCOUNT : integer;
      C_MEMMAP_TIMER3_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER3_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER4_SLOTCOUNT : integer;
      C_MEMMAP_TIMER4_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER4_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER5_SLOTCOUNT : integer;
      C_MEMMAP_TIMER5_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER5_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER6_SLOTCOUNT : integer;
      C_MEMMAP_TIMER6_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER6_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER7_SLOTCOUNT : integer;
      C_MEMMAP_TIMER7_SLOTCOUNT_N_BITS : integer;
      C_MEMMAP_TIMER7_SLOTCOUNT_BIN_PT : integer;
      C_MEMMAP_TIMER_CONTROL : integer;
      C_MEMMAP_TIMER_CONTROL_N_BITS : integer;
      C_MEMMAP_TIMER_CONTROL_BIN_PT : integer;
      C_MEMMAP_TIMERS01_SLOTTIME : integer;
      C_MEMMAP_TIMERS01_SLOTTIME_N_BITS : integer;
      C_MEMMAP_TIMERS01_SLOTTIME_BIN_PT : integer;
      C_MEMMAP_TIMERS23_SLOTTIME : integer;
      C_MEMMAP_TIMERS23_SLOTTIME_N_BITS : integer;
      C_MEMMAP_TIMERS23_SLOTTIME_BIN_PT : integer;
      C_MEMMAP_TIMERS45_SLOTTIME : integer;
      C_MEMMAP_TIMERS45_SLOTTIME_N_BITS : integer;
      C_MEMMAP_TIMERS45_SLOTTIME_BIN_PT : integer;
      C_MEMMAP_TIMERS67_SLOTTIME : integer;
      C_MEMMAP_TIMERS67_SLOTTIME_N_BITS : integer;
      C_MEMMAP_TIMERS67_SLOTTIME_BIN_PT : integer
    );
    port (
      splb_clk : in std_logic;
      idlefordifs : in std_logic;
      plb_abus : in std_logic_vector(0 to (32-1));
      plb_pavalid : in std_logic;
      plb_rnw : in std_logic;
      plb_wrdbus : in std_logic_vector(0 to (C_SPLB_DWIDTH-1));
      splb_rst : in std_logic;
      sl_addrack : out std_logic;
      sl_rdcomp : out std_logic;
      sl_rddack : out std_logic;
      sl_rddbus : out std_logic_vector(0 to (C_SPLB_DWIDTH-1));
      sl_wait : out std_logic;
      sl_wrcomp : out std_logic;
      sl_wrdack : out std_logic;
      timer0_active : out std_logic;
      timer1_active : out std_logic;
      timer2_active : out std_logic;
      timer3_active : out std_logic;
      timer4_active : out std_logic;
      timer5_active : out std_logic;
      timer6_active : out std_logic;
      timer7_active : out std_logic;
      timerexpire : out std_logic
    );
  end component;

begin

  warp_timer_plbw_0 : warp_timer_plbw
    generic map (
      C_BASEADDR => X"cd400000",
      C_HIGHADDR => X"cd40ffff",
      C_SPLB_AWIDTH => 32,
      C_SPLB_DWIDTH => 64,
      C_SPLB_P2P => 0,
      C_SPLB_MID_WIDTH => 2,
      C_SPLB_NUM_MASTERS => 3,
      C_SPLB_SUPPORT_BURSTS => 0,
      C_SPLB_NATIVE_DWIDTH => 32,
      C_MEMMAP_TIMER_STATUS => 16#834#,
      C_MEMMAP_TIMER_STATUS_N_BITS => 32,
      C_MEMMAP_TIMER_STATUS_BIN_PT => 0,
      C_MEMMAP_TIMER0_SLOTCOUNT => 16#800#,
      C_MEMMAP_TIMER0_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER0_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER1_SLOTCOUNT => 16#804#,
      C_MEMMAP_TIMER1_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER1_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER2_SLOTCOUNT => 16#808#,
      C_MEMMAP_TIMER2_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER2_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER3_SLOTCOUNT => 16#80C#,
      C_MEMMAP_TIMER3_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER3_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER4_SLOTCOUNT => 16#810#,
      C_MEMMAP_TIMER4_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER4_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER5_SLOTCOUNT => 16#814#,
      C_MEMMAP_TIMER5_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER5_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER6_SLOTCOUNT => 16#818#,
      C_MEMMAP_TIMER6_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER6_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER7_SLOTCOUNT => 16#81C#,
      C_MEMMAP_TIMER7_SLOTCOUNT_N_BITS => 32,
      C_MEMMAP_TIMER7_SLOTCOUNT_BIN_PT => 0,
      C_MEMMAP_TIMER_CONTROL => 16#820#,
      C_MEMMAP_TIMER_CONTROL_N_BITS => 32,
      C_MEMMAP_TIMER_CONTROL_BIN_PT => 0,
      C_MEMMAP_TIMERS01_SLOTTIME => 16#824#,
      C_MEMMAP_TIMERS01_SLOTTIME_N_BITS => 32,
      C_MEMMAP_TIMERS01_SLOTTIME_BIN_PT => 0,
      C_MEMMAP_TIMERS23_SLOTTIME => 16#828#,
      C_MEMMAP_TIMERS23_SLOTTIME_N_BITS => 32,
      C_MEMMAP_TIMERS23_SLOTTIME_BIN_PT => 0,
      C_MEMMAP_TIMERS45_SLOTTIME => 16#82C#,
      C_MEMMAP_TIMERS45_SLOTTIME_N_BITS => 32,
      C_MEMMAP_TIMERS45_SLOTTIME_BIN_PT => 0,
      C_MEMMAP_TIMERS67_SLOTTIME => 16#830#,
      C_MEMMAP_TIMERS67_SLOTTIME_N_BITS => 32,
      C_MEMMAP_TIMERS67_SLOTTIME_BIN_PT => 0
    )
    port map (
      splb_clk => splb_clk,
      idlefordifs => idlefordifs,
      plb_abus => plb_abus,
      plb_pavalid => plb_pavalid,
      plb_rnw => plb_rnw,
      plb_wrdbus => plb_wrdbus,
      splb_rst => splb_rst,
      sl_addrack => sl_addrack,
      sl_rdcomp => sl_rdcomp,
      sl_rddack => sl_rddack,
      sl_rddbus => sl_rddbus,
      sl_wait => sl_wait,
      sl_wrcomp => sl_wrcomp,
      sl_wrdack => sl_wrdack,
      timer0_active => timer0_active,
      timer1_active => timer1_active,
      timer2_active => timer2_active,
      timer3_active => timer3_active,
      timer4_active => timer4_active,
      timer5_active => timer5_active,
      timer6_active => timer6_active,
      timer7_active => timer7_active,
      timerexpire => timerexpire
    );

end architecture STRUCTURE;

